//+----------------------------------------------------------------------------------------------------------------------------+
//|                                                                                            ZH_StandardFunctionsTfH6.lib.mq4|
//|                                                                                            Copyright  Zhunko              |
//|09.10.2009 - 12.10.2009                                                                     F ZHUNKO vadim@zhunko.ru       |
//+----------------------------------------------------------------------------------------------------------------------------+
//|      H6.                                                                                       |
//+----------------------------------------------------------------------------------------------------------------------------+
//|1.    H6.                                                                                                 |
//|  int iBars_H6 (string symbol); //   .                                                              |
//+----------------------------------------------------------------------------------------------------------------------------+
//|2.      H6.                                                                                            |
//|  int iBarShift_H6 (string   symbol, //   .                                                         |
//|                    datetime time,   //    .                                                        |
//|                    bool     exact)  //                                                  |
//|                                     // (FALSE - iBarShift  /TRUE - iBarShift  -1).            |
//+----------------------------------------------------------------------------------------------------------------------------+
//|3.       H6.                                                                                    |
//|  datetime iTime_H6 (string symbol, //                                                              |
//|                     int    shift)  //  .                                                                          |
//+----------------------------------------------------------------------------------------------------------------------------+
//|4.      H6.                                                                                    |
//|  double iOpen_H6 (string symbol, //   .                                                            |
//|                   int    shift)  //  .                                                                            |
//+----------------------------------------------------------------------------------------------------------------------------+
//|5.      H6.                                                                                |
//|  double iHigh_H6 (string symbol, //   .                                                            |
//|                   int    shift)  //  .                                                                            |
//+----------------------------------------------------------------------------------------------------------------------------+
//|6.      H6.                                                                                 |
//|  double iLow_H6 (string symbol, //  .                                                                         |
//|                  int    shift)  //  .                                                                             |
//+----------------------------------------------------------------------------------------------------------------------------+
//|7.      H6.                                                                                    |
//|  double iClose_H6 (string symbol, //   .                                                           |
//|                    int    shift)  //  .                                                                           |
//+----------------------------------------------------------------------------------------------------------------------------+
//|8.           .                           |
//|    int Hour6()                                                                                                             |
//+----------------------------------------------------------------------------------------------------------------------------+
//|9.         .                                                     |
//|   int TimeHour6 (datetime time) // ,     ,   00:00 1  1970 .|
//+----------------------------------------------------------------------------------------------------------------------------+
//
#property copyright "Copyright  2006 Zhunko"
#property link      "vadim@zhunko.ru"
#property library
//
// 1.     H6.
int iBars_H6 (string symbol) //   .
 {
  bool     Switch_H1 = true; //        .
  bool     Switch_H2 = true; //        .
  bool     Switch_H3 = true; //        .
  bool     Switch_H4 = true; //        .
  datetime iTimeH1;          //    .
  int      i;
  int      iBarsH1;          //     H1  .
  int      iBarsH6;          //     H6.
  //----
  iBarsH1 = iBars (symbol, PERIOD_H1); //     H1  .
  for (i = 0, iBarsH6 = 0; i < iBarsH1; i++)
   {
    iTimeH1 = iTime (symbol, PERIOD_H1, i); //    .
    if (i > 0) //      .
     {//   ,    .            (  ).
      if (MathMod (TimeDay (iTimeH1), TimeDay (iTime (symbol, PERIOD_H1, i - 1))) != 0)
       {
        Switch_H1 = true; //        .
        Switch_H2 = true; //        .
        Switch_H3 = true; //        .
        Switch_H4 = true; //        .
       }
     }
    //    .
    switch (TimeHour (iTimeH1))
     {//----  4-  .-----------------------------------------------------------------------------------------
      case 23:
      case 22:
      case 21:
      case 20:
      case 19:
      case 18:
       {
        Switch_H3 = true;      //      3-  .
        Switch_H2 = true;      //      2-  .
        Switch_H1 = true;      //      1-  .
        if (Switch_H4 == true) //   .
         {
          iBarsH6++;           //   .
          Switch_H4 = false;   //         .
          break;               //   .
         }
        else continue;         //    ,       .
       }
      //----  3-  .-----------------------------------------------------------------------------------------
      case 17:
      case 16:
      case 15:
      case 14:
      case 13:
      case 12:
       {
        Switch_H4 = true;      //      4-  .
        Switch_H2 = true;      //      2-  .
        Switch_H1 = true;      //      1-  .
        if (Switch_H3 == true) //   .
         {
          iBarsH6++;           //   .
          Switch_H3 = false;   //         .
          break;               //   .
         }
        else continue;         //    ,       .
       }
      //----  2-  .-----------------------------------------------------------------------------------------
      case 11:
      case 10:
      case  9:
      case  8:
      case  7:
      case  6:
       {
        Switch_H4 = true;      //      4-  .
        Switch_H3 = true;      //      3-  .
        Switch_H1 = true;      //      1-  .
        if (Switch_H2 == true) //   .
         {
          iBarsH6++;           //   .
          Switch_H2 = false;   //         .
          break;               //   .
         }
        else continue;         //    ,       .
       }
      //----  1-  .-----------------------------------------------------------------------------------------
      case 5:
      case 4:
      case 3:
      case 2:
      case 1:
      case 0:
       {
        Switch_H4 = true;      //      4-  .
        Switch_H3 = true;      //      3-  .
        Switch_H2 = true;      //      2-  .
        if (Switch_H1 == true) //   .
         {
          iBarsH6++;           //   .
          Switch_H1 = false;   //         .
          break;               //   .
         }
        else continue;         //    ,       .
       }
     }
   }
  return (iBarsH6);
 }
//
// 2.       H6.
int iBarShift_H6 (string   symbol, //   .
                  datetime time,   //    .
                  bool     exact)  //       (FALSE - iBarShift  /TRUE - iBarShift  -1).
 {
  bool     Switch_H1 = true; //        .
  bool     Switch_H2 = true; //        .
  bool     Switch_H3 = true; //        .
  bool     Switch_H4 = true; //        .
  datetime TimeFirst_H6;     //     H6  .    .
  datetime TimeLast_H6;      //     H6  .
  datetime iTimeH1;          //      H1.
  datetime iTimeH6_0;        //      H6.
  datetime iTimeH6_1;        //      H6.
  int      AmountBar;        //         .
  int      i, j;
  int      ShiftH6 = 0;      //       H6.
  int      iBarsH1;          //     H1  .
  int      NumberHour;       //  .
  //==== .================================================================================================================================================================================================================
  iBarsH1 = iBars (symbol, PERIOD_H1);                    //     H1  .
  //====       .    .==========================================================================================================================================
  TimeFirst_H6 = iTime (symbol, PERIOD_H1, iBarsH1 - 1);  //       .
  NumberHour = TimeHour (TimeFirst_H6) + 1;               //    1  24.
  //       .
  AmountBar = MathMod (NumberHour, 6);                    //      H6,      .
  if (AmountBar > 0) AmountBar = 6 - AmountBar;           //       H6,  .
  for (i = 0; i <= AmountBar; i++) TimeFirst_H6 += 3600;  //   .
  //====       .===================================================================================================================================================================
  TimeLast_H6 = iTime (symbol, PERIOD_H1, 0);             //       .
  NumberHour = TimeHour (TimeLast_H6) + 1;                //    1  24.
  //       .
  AmountBar = MathMod (NumberHour, 6);                    //     .
  if (AmountBar == 0) AmountBar = 5;                      //      H6,      .
  else AmountBar = AmountBar - 1;                         //       H6,  .
  for (i = 0; i < AmountBar; i++) TimeLast_H6 -= 3600;    //   .
  //----.---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
//  Comment ("TimeFirst_H6 = ", TimeToStr (TimeFirst_H6, TIME_DATE|TIME_MINUTES|TIME_SECONDS), "\nLastQuarter = ", TimeToStr (TimeLast_H6, TIME_DATE|TIME_MINUTES|TIME_SECONDS));
  //======================================================================================================================================================================================================================================
  if (time < TimeFirst_H6 || time >= TimeLast_H6)              //     ,              . 
   {
    if (exact == true) return (-1);                            //   ,   -1    .
    else                                                       //   ,       () .
     {
      if (time < TimeFirst_H6) return (iBars_H6 (symbol) - 1); //          ,   .
      if (time > TimeLast_H6) return (0);                      //          ,   .
     }
   }
  else                                                      //       .
   {//      H6.
    iTimeH6_0 = iTime (symbol, PERIOD_H1, 0);               //       .
    NumberHour = TimeHour (iTimeH6_0) + 1;                  //  .
    AmountBar = MathMod (NumberHour, 6);                    //      H6,      .
    if (AmountBar > 0) AmountBar = 6 - AmountBar;           //       H6,  .
    for (i = 0; i <= AmountBar; i++) TimeFirst_H6 += 3600;  //   .
    for (i = 0, ShiftH6 = -1; i < iBarsH1; i++)             //    .    .
     {
      iTimeH1 = iTime (symbol, PERIOD_H1, i);               //     .
      //        .         H1.
      if (i > 0) //      .
       {//   ,    .            (  ).
        if (MathMod (TimeDay (iTimeH1), TimeDay (iTime (symbol, PERIOD_H1, i - 1))) != 0)
         {
          Switch_H1 = true; //        .
          Switch_H2 = true; //        .
          Switch_H3 = true; //        .
          Switch_H4 = true; //        .
         }
       }
      //    .
      NumberHour = TimeHour (iTimeH1); //  .
      switch (NumberHour)
       {//----  4-  .--------------------------------------------------------------------------------------
        case 23:
        case 22:
        case 21:
        case 20:
        case 19:
        case 18:
         {
          Switch_H3 = true;       //      3-  .
          Switch_H2 = true;       //      2-  .
          Switch_H1 = true;       //      1-  .
          if (Switch_H4 == true)  //   .
           {
            ShiftH6++;            //   .
            Switch_H4 = false;    //         .
            break;                //   .
           }
          else continue;          //    ,       .
         }
        //----  3-  .--------------------------------------------------------------------------------------
        case 17:
        case 16:
        case 15:
        case 14:
        case 13:
        case 12:
         {
          Switch_H4 = true;      //      4-  .
          Switch_H2 = true;      //      2-  .
          Switch_H1 = true;      //      1-  .
          if (Switch_H3 == true) //   .
           {
            ShiftH6++;           //   .
            Switch_H3 = false;   //         .
            break;               //   .
           }
          else continue;         //    ,       .
         }
        //----  2-  .--------------------------------------------------------------------------------------
        case 11:
        case 10:
        case  9:
        case  8:
        case  7:
        case  6:
         {
          Switch_H4 = true;      //      4-  .
          Switch_H3 = true;      //      3-  .
          Switch_H1 = true;      //      1-  .
          if (Switch_H2 == true) //   .
           {
            ShiftH6++;           //   .
            Switch_H2 = false;   //         .
            break;               //   .
           }
          else continue;         //    ,       .
         }
        //----  1-  .--------------------------------------------------------------------------------------
        case 5:
        case 4:
        case 3:
        case 2:
        case 1:
        case 0:
         {
          Switch_H4 = true;      //      4-  .
          Switch_H3 = true;      //      3-  .
          Switch_H2 = true;      //      2-  .
          if (Switch_H1 == true) //   .
           {
            ShiftH6++;           //   .
            Switch_H1 = false;   //         .
            break;               //   .
           }
          else continue;         //    ,       .
         }
       }
      //   ,       "" .
      if (exact == true)
       {//      .
        iTimeH6_1 = iTimeH1;                                   //       .
        //       .
        AmountBar = MathMod (NumberHour + 1, 6);               //     ,      .
        if (AmountBar > 0) AmountBar = 6 - AmountBar;          //      ,  .
        for (j = 0; j <= AmountBar; j++) iTimeH6_1 += 3600;    //           H6.
        //   ""  .
        if (iTimeH6_1 < time && time < iTimeH6_0) return (-1); //  -1    .
       }
      //      .
      iTimeH6_0 = iTimeH1;                               //       .
      //       .
      AmountBar = MathMod (NumberHour + 1, 6);           //     .
      if (AmountBar == 0) AmountBar = 5;                 //     ,      .
      else AmountBar = AmountBar - 1;                    //      ,  .
      for (j = 0; j < AmountBar; j++) iTimeH6_0 -= 3600; //           H6.
      if (time >= iTimeH6_0) return (ShiftH6);           //      H6.
     }
   }
 }
//
// 3.        H6.
datetime iTime_H6 (string symbol, //   
                   int    shift)  //  .
 {
  bool     Switch_H1 = true; //        .
  bool     Switch_H2 = true; //        .
  bool     Switch_H3 = true; //        .
  bool     Switch_H4 = true; //        .
  datetime iTimeH1;          //    .
  datetime iTimeH6;          //  .
  int      AmountBar;        //         .
  int      i, j;
  int      iBarsH1 = iBars (symbol, PERIOD_H1); //     H1  .
  int      iBarsH6 = iBars_H6 (symbol);         //     H6.
  int      NumberHour;                          //  .
  int      ShiftH6;                             //     H6.
  //----
  if (0 > shift || shift >= iBarsH6) return (0); //     .
  else                                           //       ,  .
   {//    .   .
    for (i = 0, ShiftH6 = -1; i < iBarsH1; i++)  //     .
     {
      iTimeH1 = iTime (symbol, PERIOD_H1, i);    //    .
      if (i > 0) //      .
       {//   ,    .            (  ).
        if (MathMod (TimeDay (iTimeH1), TimeDay (iTime (symbol, PERIOD_H1, i - 1))) != 0)
         {
          Switch_H1 = true; //        .
          Switch_H2 = true; //        .
          Switch_H3 = true; //        .
          Switch_H4 = true; //        .
         }
       }
      //    .
      NumberHour = TimeHour (iTimeH1); //  .
      switch (NumberHour)
       {//----  4-  .-----------------------------------------------------------------------------------------
        case 23:
        case 22:
        case 21:
        case 20:
        case 19:
        case 18:
         {
          Switch_H3 = true;       //      3-  .
          Switch_H2 = true;       //      2-  .
          Switch_H1 = true;       //      1-  .
          if (Switch_H4 == true)  //   .
           {
            ShiftH6++;            //   .
            Switch_H4 = false;    //         .
            break;                //   .
           }
          else continue;          //    ,       .
         }
        //----  3-  .-----------------------------------------------------------------------------------------
        case 17:
        case 16:
        case 15:
        case 14:
        case 13:
        case 12:
         {
          Switch_H4 = true;       //      4-  .
          Switch_H2 = true;       //      2-  .
          Switch_H1 = true;       //      1-  .
          if (Switch_H3 == true)  //   .
           {
            ShiftH6++;            //   .
            Switch_H3 = false;    //         .
            break;                //   .
           }
          else continue;          //    ,       .
         }
        //----  2-  .-----------------------------------------------------------------------------------------
        case 11:
        case 10:
        case  9:
        case  8:
        case  7:
        case  6:
         {
          Switch_H4 = true;       //      4-  .
          Switch_H3 = true;       //      3-  .
          Switch_H1 = true;       //      1-  .
          if (Switch_H2 == true)  //   .
           {
            ShiftH6++;            //   .
            Switch_H2 = false;    //         .
            break;                //   .
           }
          else continue;          //    ,       .
         }
        //----  1-  .-----------------------------------------------------------------------------------------
        case 5:
        case 4:
        case 3:
        case 2:
        case 1:
        case 0:
         {
          Switch_H4 = true;       //      4-  .
          Switch_H3 = true;       //      3-  .
          Switch_H2 = true;       //      2-  .
          if (Switch_H1 == true)  //   .
           {
            ShiftH6++;            //   .
            Switch_H1 = false;    //         .
            break;                //   .
           }
          else continue;          //    ,       .
         }
       }
      //    .
      if (shift == ShiftH6)
       {//      .
        iTimeH6 = iTimeH1;                               //       .
        //       .
        AmountBar = MathMod (NumberHour + 1, 6);         //     .
        if (AmountBar == 0) AmountBar = 5;               //     ,      .
        else AmountBar = AmountBar - 1;                  //      ,  .
        for (j = 0; j < AmountBar; j++) iTimeH6 -= 3600; //   .      H6.
        return (iTimeH6);                                //     .
       }
     }
   }
 }
//
// 4.       H6.
double iOpen_H6 (string symbol, //   .
                 int    shift)  //  .
 {
  bool     Switch_H1 = true; //        .
  bool     Switch_H2 = true; //        .
  bool     Switch_H3 = true; //        .
  bool     Switch_H4 = true; //        .
  datetime iTimeH1;          //    .
  int      i, j, k;
  int      iBarsH1 = iBars (symbol, PERIOD_H1); //     H1  .
  int      iBarsH6 = iBars_H6 (symbol);         //     H6.
  int      FirstH1;                             //     6-  .
  int      ShiftH6;                             //     H6.
  //----
  if (0 > shift || shift >= iBarsH6) return (0); //     .
  else                                           //       ,  .
   {
    for (i = 0, ShiftH6 = -1; i < iBarsH1; i++)  //     .
     {
      iTimeH1 = iTime (symbol, PERIOD_H1, i);    //    .
      if (i > 0) //      .
       {//   ,    .            (  ).
        if (MathMod (TimeDay (iTimeH1), TimeDay (iTime (symbol, PERIOD_H1, i - 1))) != 0)
         {
          Switch_H1 = true; //        .
          Switch_H2 = true; //        .
          Switch_H3 = true; //        .
          Switch_H4 = true; //        .
         }
       }
      //    .
      switch (TimeHour (iTimeH1))
       {//----  4-  .---------------------------------------------------------------------------------------------------------
        case 23:
        case 22:
        case 21:
        case 20:
        case 19:
        case 18:
         {
          Switch_H3 = true;       //      3-  .
          Switch_H2 = true;       //      2-  .
          Switch_H1 = true;       //      1-  .
          if (Switch_H4 == true)  //   .
           {
            ShiftH6++;            //   .
            FirstH1 = 18;         //     6-  .
            Switch_H4 = false;    //         .
            break;                //   .
           }
          else continue;          //    ,       .
         }
        //----  3-  .---------------------------------------------------------------------------------------------------------
        case 17:
        case 16:
        case 15:
        case 14:
        case 13:
        case 12:
         {
          Switch_H4 = true;       //      4-  .
          Switch_H2 = true;       //      2-  .
          Switch_H1 = true;       //      1-  .
          if (Switch_H3 == true)  //   .
           {
            ShiftH6++;            //   .
            FirstH1 = 12;         //     6-  .
            Switch_H3 = false;    //         .
            break;                //   .
           }
          else continue;          //    ,       .
         }
        //----  2-  .---------------------------------------------------------------------------------------------------------
        case 11:
        case 10:
        case  9:
        case  8:
        case  7:
        case  6:
         {
          Switch_H4 = true;       //      4-  .
          Switch_H3 = true;       //      3-  .
          Switch_H1 = true;       //      1-  .
          if (Switch_H2 == true)  //   .
           {
            ShiftH6++;            //   .
            FirstH1 = 6;          //     6-  .
            Switch_H2 = false;    //         .
            break;                //   .
           }
          else continue;          //    ,       .
         }
        //----  1-  .---------------------------------------------------------------------------------------------------------
        case 5:
        case 4:
        case 3:
        case 2:
        case 1:
        case 0:
         {
          Switch_H4 = true;       //      4-  .
          Switch_H3 = true;       //      3-  .
          Switch_H2 = true;       //      2-  .
          if (Switch_H1 == true)  //   .
           {
            ShiftH6++;            //   .
            FirstH1 = 0;          //     6-  .
            Switch_H1 = false;    //         .
            break;                //   .
           }
          else continue;          //    ,       .
         }
        //--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
       }
      if (shift == ShiftH6)                       //    .
       {
        for (i++, k = TimeDay (iTimeH1);; i++)    //      .
         {
          iTimeH1 = iTime (symbol, PERIOD_H1, i); //    .
          //     6-        .  ,         .    6-  .
          if (FirstH1 == 0) {if (TimeHour (iTimeH1) > 5 || TimeDay (iTimeH1) != k) return (iOpen (symbol, PERIOD_H1, i - 1));}
          else {if (TimeHour (iTimeH1) < FirstH1 || TimeDay (iTimeH1) != k) return (iOpen (symbol, PERIOD_H1, i - 1));}
         }
       }
     }
   }
 }
//
// 5.       H6.
double iHigh_H6 (string symbol, //   .
                 int    shift)  //  .
 {
  bool     Switch_H1 = true; //        .
  bool     Switch_H2 = true; //        .
  bool     Switch_H3 = true; //        .
  bool     Switch_H4 = true; //        .
  datetime iTimeH1;          //    .
  datetime iTimeH1_1;        //     .
  int      i, l;
  int      iBarsH1 = iBars (symbol, PERIOD_H1); //     H1  .
  int      iBarsH6 = iBars_H6 (symbol);         //     H6.
  int      FirstH1;                             //     6-  .
  int      ShiftH6;                             //     H6.
  // .
  double   ArHighH1[6]; //         .
  //----
  if (0 > shift || shift >= iBarsH6) return (0); //     .
  else                                           //       ,  .
   {
    for (i = 0, ShiftH6 = -1; i < iBarsH1; i++)  //     .
     {
      iTimeH1 = iTime (symbol, PERIOD_H1, i);    //    .
      if (i > 0) //      .
       {//   ,    .            (  ).
        if (MathMod (TimeDay (iTimeH1), TimeDay (iTime (symbol, PERIOD_H1, i - 1))) != 0)
         {
          Switch_H1 = true; //        .
          Switch_H2 = true; //        .
          Switch_H3 = true; //        .
          Switch_H4 = true; //        .
         }
       }
      //    .
      switch (TimeHour (iTimeH1))
       {//----  4-  .---------------------------------------------------------------------------------------------------------
        case 23:
        case 22:
        case 21:
        case 20:
        case 19:
        case 18:
         {
          Switch_H3 = true;       //      3-  .
          Switch_H2 = true;       //      2-  .
          Switch_H1 = true;       //      1-  .
          if (Switch_H4 == true)  //   .
           {
            ShiftH6++;            //   .
            FirstH1 = 18;         //     6-  .
            Switch_H4 = false;    //         .
            break;                //   .
           }
          else continue;          //    ,       .
         }
        //----  3-  .---------------------------------------------------------------------------------------------------------
        case 17:
        case 16:
        case 15:
        case 14:
        case 13:
        case 12:
         {
          Switch_H4 = true;       //      4-  .
          Switch_H2 = true;       //      2-  .
          Switch_H1 = true;       //      1-  .
          if (Switch_H3 == true)  //   .
           {
            ShiftH6++;            //   .
            FirstH1 = 12;         //     6-  .
            Switch_H3 = false;    //         .
            break;                //   .
           }
          else continue;          //    ,       .
         }
        //----  2-  .---------------------------------------------------------------------------------------------------------
        case 11:
        case 10:
        case  9:
        case  8:
        case  7:
        case  6:
         {
          Switch_H4 = true;       //      4-  .
          Switch_H3 = true;       //      3-  .
          Switch_H1 = true;       //      1-  .
          if (Switch_H2 == true)  //   .
           {
            ShiftH6++;            //   .
            FirstH1 = 6;          //     6-  .
            Switch_H2 = false;    //         .
            break;                //   .
           }
          else continue;          //    ,       .
         }
        //----  1-  .---------------------------------------------------------------------------------------------------------
        case 5:
        case 4:
        case 3:
        case 2:
        case 1:
        case 0:
         {
          Switch_H4 = true;       //      4-  .
          Switch_H3 = true;       //      3-  .
          Switch_H2 = true;       //      2-  .
          if (Switch_H1 == true)  //   .
           {
            ShiftH6++;            //   .
            FirstH1 = 0;          //     6-  .
            Switch_H1 = false;    //         .
            break;                //   .
           }
          else continue;          //    ,       .
         }
        //--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
       }
      if (shift == ShiftH6) //    .
       {
        for (l = 0; l < 6; i++, l++)   //      .
         {
          iTimeH1 = iTime (symbol, PERIOD_H1, i);             //     .
          iTimeH1_1 = iTime (symbol, PERIOD_H1, i + 1);       //     .
          ArHighH1[l] = iHigh (symbol, PERIOD_H1, i);         //        .
          //     6-        .
          if (FirstH1 == 0) {if (TimeHour (iTimeH1_1) > 5 || TimeDay (iTimeH1) != TimeDay (iTimeH1_1)) break;} //  ,         .
          else {if (TimeHour (iTimeH1_1) < FirstH1 || TimeDay (iTimeH1) != TimeDay (iTimeH1_1)) break;}        //  ,         .
         }
        return (ArHighH1[ArrayMinimum (ArHighH1, l + 1, 0)]); //     .
       }
     }
   }
 }
//
// 6.       H6.
double iLow_H6 (string symbol, //  .
                int    shift)  //  .
 {
  bool     Switch_H1 = true; //        .
  bool     Switch_H2 = true; //        .
  bool     Switch_H3 = true; //        .
  bool     Switch_H4 = true; //        .
  datetime iTimeH1;          //    .
  datetime iTimeH1_1;        //     .
  int      i, l;
  int      iBarsH1 = iBars (symbol, PERIOD_H1); //     H1  .
  int      iBarsH6 = iBars_H6 (symbol);         //     H6.
  int      FirstH1;                             //     6-  .
  int      ShiftH6;                             //     H6.
  // .
  double   ArLowH1[6]; //        6-  .
  //----
  if (0 > shift || shift >= iBarsH6) return (0); //     .
  else                                           //       ,  .
   {
    for (i = 0, ShiftH6 = -1; i < iBarsH1; i++)  //     .
     {
      iTimeH1 = iTime (symbol, PERIOD_H1, i);    //    .
      if (i > 0) //      .
       {//   ,    .            (  ).
        if (MathMod (TimeDay (iTimeH1), TimeDay (iTime (symbol, PERIOD_H1, i - 1))) != 0)
         {
          Switch_H1 = true; //        .
          Switch_H2 = true; //        .
          Switch_H3 = true; //        .
          Switch_H4 = true; //        .
         }
       }
      //    .
      switch (TimeHour (iTimeH1))
       {//----  4-  .---------------------------------------------------------------------------------------------------------
        case 23:
        case 22:
        case 21:
        case 20:
        case 19:
        case 18:
         {
          Switch_H3 = true;       //      3-  .
          Switch_H2 = true;       //      2-  .
          Switch_H1 = true;       //      1-  .
          if (Switch_H4 == true)  //   .
           {
            ShiftH6++;            //   .
            FirstH1 = 18;         //     6-  .
            Switch_H4 = false;    //         .
            break;                //   .
           }
          else continue;          //    ,       .
         }
        //----  3-  .---------------------------------------------------------------------------------------------------------
        case 17:
        case 16:
        case 15:
        case 14:
        case 13:
        case 12:
         {
          Switch_H4 = true;       //      4-  .
          Switch_H2 = true;       //      2-  .
          Switch_H1 = true;       //      1-  .
          if (Switch_H3 == true)  //   .
           {
            ShiftH6++;            //   .
            FirstH1 = 12;         //     6-  .
            Switch_H3 = false;    //         .
            break;                //   .
           }
          else continue;          //    ,       .
         }
        //----  2-  .---------------------------------------------------------------------------------------------------------
        case 11:
        case 10:
        case  9:
        case  8:
        case  7:
        case  6:
         {
          Switch_H4 = true;       //      4-  .
          Switch_H3 = true;       //      3-  .
          Switch_H1 = true;       //      1-  .
          if (Switch_H2 == true)  //   .
           {
            ShiftH6++;            //   .
            FirstH1 = 6;          //     6-  .
            Switch_H2 = false;    //         .
            break;                //   .
           }
          else continue;          //    ,       .
         }
        //----  1-  .---------------------------------------------------------------------------------------------------------
        case 5:
        case 4:
        case 3:
        case 2:
        case 1:
        case 0:
         {
          Switch_H4 = true;       //      4-  .
          Switch_H3 = true;       //      3-  .
          Switch_H2 = true;       //      2-  .
          if (Switch_H1 == true)  //   .
           {
            ShiftH6++;            //   .
            FirstH1 = 0;          //     6-  .
            Switch_H1 = false;    //         .
            break;                //   .
           }
          else continue;          //    ,       .
         }
        //--------------------------------------------------------------------------------------------------------------------------------------------------
       }
      if (shift == ShiftH6) //    .
       {
        for (l = 0; l < 6; i++, l++)  //      .
         {
          iTimeH1 = iTime (symbol, PERIOD_H1, i);           //     .
          iTimeH1_1 = iTime (symbol, PERIOD_H1, i + 1);     //     .
          ArLowH1[l] = iLow (symbol, PERIOD_H1, i);         //        .
          //     6-        .
          if (FirstH1 == 0) {if (TimeHour (iTimeH1_1) > 5 || TimeDay (iTimeH1) != TimeDay (iTimeH1_1)) break;} //  ,         .
          else {if (TimeHour (iTimeH1_1) < FirstH1 || TimeDay (iTimeH1) != TimeDay (iTimeH1_1)) break;}        //  ,         .
         }
        return (ArLowH1[ArrayMinimum (ArLowH1, l + 1, 0)]); //     .
       }
     }
   }
 }
//
// 7.       H6.
double iClose_H6 (string symbol, //   .
                  int    shift)  //  .
 {
  bool     Switch_H1 = true; //        .
  bool     Switch_H2 = true; //        .
  bool     Switch_H3 = true; //        .
  bool     Switch_H4 = true; //        .
  datetime iTimeH1;         //    .
  int      i;
  int      iBarsH1 = iBars (symbol, PERIOD_H1); //     H1  .
  int      iBarsH6 = iBars_H6 (symbol);         //        H6.
  //      .
  if (0 > shift || shift >= iBarsH6) return (0); //     .
  else                                           //       ,  .
   {
    iBarsH1 = iBars (symbol, PERIOD_H1); //     H1  .
    for (i = 0, iBarsH6 = -1; i < iBarsH1; i++)
     {
      iTimeH1 = iTime (symbol, PERIOD_H1, i); //    .
      if (i > 0) //      .
       {//   ,    .            (  ).
        if (MathMod (TimeDay (iTimeH1), TimeDay (iTime (symbol, PERIOD_H1, i - 1))) != 0)
         {
          Switch_H1 = true; //        .
          Switch_H2 = true; //        .
          Switch_H3 = true; //        .
          Switch_H4 = true; //        .
         }
       }
      //    .
      switch (TimeHour (iTimeH1))
       {//----  4-  .---------------------------------------------------------------------------------------------------------
        case 23:
        case 22:
        case 21:
        case 20:
        case 19:
        case 18:
         {
          Switch_H3 = true;      //      3-  .
          Switch_H2 = true;      //      2-  .
          Switch_H1 = true;      //      1-  .
          if (Switch_H4 == true) //   .
           {
            iBarsH6++;           //   .
            Switch_H4 = false;   //         .
            break;               //   .
           }
          else continue;         //    ,       .
         }
        //----  3-  .---------------------------------------------------------------------------------------------------------
        case 17:
        case 16:
        case 15:
        case 14:
        case 13:
        case 12:
         {
          Switch_H4 = true;      //      4-  .
          Switch_H2 = true;      //      2-  .
          Switch_H1 = true;      //      1-  .
          if (Switch_H3 == true) //   .
           {
            iBarsH6++;           //   .
            Switch_H3 = false;   //         .
            break;               //   .
           }
          else continue;         //    ,       .
         }
        //----  2-  .---------------------------------------------------------------------------------------------------------
        case 11:
        case 10:
        case  9:
        case  8:
        case  7:
        case  6:
         {
          Switch_H4 = true;      //      4-  .
          Switch_H3 = true;      //      3-  .
          Switch_H1 = true;      //      1-  .
          if (Switch_H2 == true) //   .
           {
            iBarsH6++;           //   .
            Switch_H2 = false;   //         .
            break;               //   .
           }
          else continue;         //    ,       .
         }
        //----  1-  .---------------------------------------------------------------------------------------------------------
        case 5:
        case 4:
        case 3:
        case 2:
        case 1:
        case 0:
         {
          Switch_H4 = true;      //      4-  .
          Switch_H3 = true;      //      3-  .
          Switch_H2 = true;      //      2-  .
          if (Switch_H1 == true) //   .
           {
            iBarsH6++;           //   .
            Switch_H1 = false;   //         .
            break;               //   .
           }
          else continue;         //    ,       .
         }
        //--------------------------------------------------------------------------------------------------------------------------------------------------
       }
      if (shift == iBarsH6) return (iClose (symbol, PERIOD_H1, i)); //    .     .
     }
   }
 }
//
// 8.           .
int Hour6()
 {
  switch (Hour())
   {
    case  0:
    case  1:
    case  2:
    case  3:
    case  4:
    case  5: return  (1);
    case  6:
    case  7:
    case  8:
    case  9:
    case 10:
    case 11: return  (2);
    case 12:
    case 13:
    case 14:
    case 15:
    case 16:
    case 17: return  (3);
    case 18:
    case 19:
    case 20:
    case 21:
    case 22:
    case 23: return  (4);
   }
 }
//
// 8.           .
int TimeHour6 (datetime time)
 {
  switch (TimeHour (time)) // ,     ,   00:00 1  1970 .
   {
    case  0:
    case  1:
    case  2:
    case  3:
    case  4:
    case  5: return  (1);
    case  6:
    case  7:
    case  8:
    case  9:
    case 10:
    case 11: return  (2);
    case 12:
    case 13:
    case 14:
    case 15:
    case 16:
    case 17: return  (3);
    case 18:
    case 19:
    case 20:
    case 21:
    case 22:
    case 23: return  (4);
   }
 }
//

